        EXTERNAL MY_USER_OPEN
        INTEGER*4 EBK, FFB
        COMMON/X/ EBK, FFB

        OPEN (UNIT=1,FILE='TEST',STATUS='OLD',
        1  FORM='UNFORMATTED',RECL=10000,USEROPEN=MY_USER_OPEN)
        CLOSE (1)
        TYPE *, EBK,FFB
        END

        INTEGER*4 FUNCTION MY_USER_OPEN (FAB,RAB,LUN)
!
! USEROPEN routine which is called by the RTL to do the RMS create and
! connect operations.  It is passed the RMS FAB and RAB control blocks
! which were already allocated and filled in by the RTL.  Attached to
! the FAB is one or more XAB blocks, including an XABFHC block.
! This routine will search through the chain of XABs looking for the XABFHC.
! Because VAX FORTRAN doesn't have a "pointer" type, a second routine is
! used to access individual XABs. (DEC FORTRAN does have pointers)
!
! The return value is the completion status.
!
! For more information on USEROPEN routines, see the VAX FORTRAN
! User Manual.
!
        INCLUDE '($FABDEF)' ! FAB structure definition
        INCLUDE '($RABDEF)' ! RAB structure definition
        INCLUDE '($SYSSRVNAM)' ! System service definitions

        RECORD /FABDEF/ FAB ! File Access Block argument
        RECORD /RABDEF/ RAB ! Record Access Block argument

        INTEGER FIND_XABFHC
        INTEGER XAB_POINTER ! Pointer to current XAB

! Open the file.  If any error, return with the error status.
!
        MY_USER_OPEN = SYS$OPEN (FAB)
        IF (.NOT. MY_USER_OPEN) RETURN

! Now connect the record stream and return.
! (This is needed in general, but not for this example)
!
        MY_USER_OPEN = SYS$CONNECT (RAB)

! Now get the first XAB in the FAB's chain
!
        XAB_POINTER = FAB.FAB$L_XAB

! While there are still XABs left, call FIND_XABFHC with current XAB.
! That routine will look to see if the XAB is the XABFHC it is, grab
! the EBK/LRL values.  It will also return as its function result the
! next XAB in the chain, if any.
! The %VAL is necessary to "de-reference" the pointer.
!
        DO WHILE (XAB_POINTER .NE. 0)
          XAB_POINTER = FIND_XABFHC (%VAL(XAB_POINTER))
          END DO

        RETURN
        END

        INTEGER*4 FUNCTION FIND_XABFHC (XAB)
!
! Worker function called by MY_USER_OPEN to grab info from XABFHC.
!
        INCLUDE '($XABDEF)' ! Structure common to all XABs
        INCLUDE '($XABFHCDEF)' ! XABFHC structure
        INTEGER*4 EBK, FFB
        COMMON/X/ EBK, FFB

! Create a structure for the XAB which contains both the common field
! names and those specific to XABKEYs.
!
        STRUCTURE /XABFHC_STRUCT/
          UNION
            MAP
            RECORD /XABDEF/ XABCOMMON
            END MAP
            MAP
            RECORD /XABFHCDEF/ XABFHC
            END MAP
          END UNION
        END STRUCTURE

! Now declare the XAB using the structure we just defined
!
        RECORD /XABFHC_STRUCT/ XAB

! Get the next XAB in the chain, if any
!
        FIND_XABFHC = XAB.XABCOMMON.XAB$L_NXT

! This the one?
!
        IF (XAB.XABCOMMON.XAB$B_COD .EQ. XAB$C_FHC) THEN
            EBK = XAB.XABFHC.XAB$L_EBK
            FFB = XAB.XABFHC.XAB$W_FFB
        END IF
        RETURN
        END

